var Country = "US";
var scroller = null;
var AmazonBaseURL = "http://webservices.amazon.com/onca/xml";
var SubscriptionID = "1NPD6TET1AEJ93JEH882";
var waitTimer = null;
var waitCount = 0;

var selectedSearchIndex = "Blended";
var sortOrder = '';
var reviewLoad = true;
var ResultStatus = { keywords     : null, 
                     totalResults : null,
                     totalPages   : null,
                     searchIndex  : null,
                     pageNumber   : null };


function debug( message ) {
    //if ( window.Logger ) {
    if ( window.SimpleABAccess ) {
        if ( message != null ) {
            SimpleABAccess.log( message );//.toString() );
        } else {
            SimpleABAccess.log( "Null" );
        }
        return;
    }
    var div = document.getElementById( "debug" );
    if ( message == null ) {
        message = "NULL";
    }
    if ( div ) {
        div.appendChild( document.createTextNode( message ) );
        div.appendChild( document.createElement( "br" ) );
    }

}

function tr( key, defvalue ) {
    if ( defvalue == null ) defvalue = key;
    try {
        var localized = localizedStrings[ key ];
        if ( localized ) {
            return localized;
        }
        return defvalue;
    } catch ( e ) {
        return defvalue;
    }
}

function init() {
    createInformationButton( document.getElementById( "front" ), -13, -30, flipToBack, false, 1200 );

    //createInformationButton( document.getElementById( "front" ), -20, -20, flipToBack, true, 1000 );

    createGenericButton( document.getElementById( "done" ), "Done", flipToFront );

    window.addEventListener( "mousewheel", receiveWheelEvent, true );

    setupButtonActions();
    try {
        initMailData();
    } catch ( e ) {
        debug( e );
    }

    if ( window.widget ) {
        var country = widget.preferenceForKey( "COUNTRY" );
        if ( country ) {
            _changeCountry( country );
        } else {
            var default_country = "US";
            try {
                default_country = localizedStrings[ "DEFAULT_COUNTRY_CODE" ];
            } catch ( e ) {}
            _changeCountry( default_country );
        }

        widget.setCloseBoxOffset( 20, 190 );

        sortOrder = widget.preferenceForKey( _getSortKey( Country, null ) );

        var check_review = widget.preferenceForKey( "DEFAULT_REVIEW_LOAD" );
        var check_box = document.getElementById( "review" );
        if ( check_review == "false" ) {
            reviewLoad = false;
            check_box.removeAttribute( "checked" );
        } else if ( check_review == "true" ) {
            reviewLoad = true;
            check_box.setAttribute( "checked", "true" );
        }
    }

    // resize handle
    var handle = document.getElementById( "handle" );
    if ( handle ) {
        handle.addEventListener( "mousedown", startResizing, true );
    }

    // read images of wait timer
    for ( var i = 0; i < 12; i++ ) {
        (new Image()).src = "Images/Wait" + i + ".png";
    }
    ( new Image()).src = "Images/ForwardButton.png";
    ( new Image()).src = "Images/ForwardButtonActivated.png";
    ( new Image()).src = "Images/ForwardButtonDisabled.png";
    ( new Image()).src = "Images/ForwardButton.png";
    ( new Image()).src = "Images/ForwardButtonActivated.png";
    ( new Image()).src = "Images/ForwardButtonDisabled.png";

    ( new Image()).src = "Images/ExpandedTop.png";
    ( new Image()).src = "Images/ExpandedBottom.png";
    ( new Image()).src = "Images/ExpandedBody.png";

    // localization
    var elements = document.getElementsByTagName( "SPAN" );
    for ( var i = 0; i < elements.length; i++ ) {
        var elem = elements[ i ];
        if ( elem.localizationKey ) {
            elem.innerText = tr( elem.localizationKey );
            //debug( elem.localizationKey + "=" + tr( elem.localizationKey ) );
        }
    }
    elements = document.getElementsByTagName( "OPTION" );
    for ( var i = 0; i < elements.length; i++ ) {
        var elem = elements[ i ];
        if ( elem.localizationKey ) {
            elem.innerText = tr( elem.localizationKey );
            debug( elem.localizationKey + "=" + tr( elem.localizationKey ) );
        }
    }
}

var resizeParameter = { 
    lastx   :0, lasty    :0,
    x       :0, y        :170,
    width   :0, height   :0,
    minWidth:0, minHeight:220,
    maxWidth:0, maxHeight:600,
    target  :null
};
var lastPos = { x:0, y:0 };
function startResizing( event ) {
    resizeParameter.lastx = event.x;
    resizeParameter.lasty = event.y;
    var target = document.getElementById( "front" );
    resizeParameter.target = target;
    var style = document.defaultView.getComputedStyle( target );
    resizeParameter.x = parseInt( style.getPropertyValue( "left" ) );
    resizeParameter.y = parseInt( style.getPropertyValue( "top" ) );
    resizeParameter.width = parseInt( style.getPropertyValue( "width" ) );
    resizeParameter.height = parseInt( style.getPropertyValue( "height" ) );
    window.addEventListener( "mouseup", endResizing, true );
    window.addEventListener( "mousemove", resizeWindow, true );
}

function resizeWindow( event ) {
    var x = event.x;
    var y = event.y;
    var dy = y - resizeParameter.lasty;
    var ty = resizeParameter.y - dy;
    var th = resizeParameter.height + dy + dy;
    if ( ty < 0 ) {
        ty = 0;
        th = resizeParameter.height + dy;
    }
    if ( th > resizeParameter.maxHeight ) {
        th = resizeParameter.maxHeight;
    }
    if ( th < resizeParameter.minHeight ) {
        dy = ( resizeParameter.minHeight - resizeParameter.height ) / 2;
        ty = resizeParameter.y - dy;
        th = resizeParameter.minHeight;
    }
    resizeParameter.target.style.top = ty + "px";
    resizeParameter.target.style.height = th + "px";
    resizeParameter.y = ty;
    resizeParameter.height = th;
    resizeParameter.lasty = y;
    window.resizeBy( 0, dy );
    if ( window.widget ) {
        widget.setCloseBoxOffset( 10, ty + 20 );
    }
    if ( ViewStatus.expander ) {
        ViewStatus.expander.size2.height = th;
        ViewStatus.expander.location.y = ty;
    }
    if ( scroller != null ) {
        scroller.refresh();
    }
}

function endResizing( event ) {
    window.removeEventListener( "mouseup", endResizing, true );
    window.removeEventListener( "mousemove", resizeWindow, true );
}

function setupButtonActions() {
    new ButtonListener( "forwardButton", goForward, "Images/ForwardButton" );
    new ButtonListener( "backwardButton", goBackward, "Images/BackwardButton" );
    new ButtonListener( "detailClose", closeDetailedInformation, "Images/CloseButton" );
    new ButtonListener( "detailGo", goAmazon, "Images/GoButton2" );
    new ButtonListener( "detailMail", sendMail, "Images/MailButton" );
}

function closeDetailedInformation() {
    var panel = document.getElementById( "detailPanel" );
    if ( panel ) {
        panel.style.display = "none";
    }
}
function goAmazon() {
    if ( window.widget ) {
        widget.openURL( MailData.attachedURL );
    } else {
        window.openURL( MailData.attachedURL );
    }
}

function refreshButtonImages() {
    var forward = document.getElementById( "forwardButton" );
    var backward = document.getElementById( "backwardButton" );
    forward.available = false;
    backward.available = false;
    if ( ResultStatus.pageNumber == null ) {
        forward.src = "Images/ForwardButtonDisabled.png";
        backward.src= "Images/BackwardButtonDisabled.png";
    } else {
        if ( ResultStatus.pageNumber < ResultStatus.totalPages ) {
            forward.src = "Images/ForwardButton.png";
            forward.available = true;
        } else {
            forward.src = "Images/ForwardButtonDisabled.png";
        }
        if ( ResultStatus.pageNumber > 1 ) {
            backward.src = "Images/BackwardButton.png";
            backward.available = true;
        } else {
            backward.src = "Images/BackwardButtonDisabled.png";
        }
    }

    var mail_button = document.getElementById( "detailMail" );
    //debug( "address " + ( MailData.toAddress != null ) + ", name " + ( MailData.toName ) );
    if ( MailData.toAddress != null && MailData.toName != null ) {
        mail_button.available = true;
        mail_button.src = "Images/MailButton.png";
    } else {
        mail_button.available = false;
        mail_button.src = "Images/MailButtonDisabled.png";
    }
    
}

function ButtonListener( id, handler, imageBase ) {
    this.element = document.getElementById( id );
    if ( this.element ) {
        this.element.style.appleDashboardRegion = "dashboard-region(control circle)";
        this.element.ButtonListener = this;
        this.element.addEventListener( "mousedown", ButtonListener__mouseDown, true );
        this.handler = handler;
        this.imageBase = imageBase;
    } else {
        debug( "NO ELEMENT " + id );
    }
}

function ButtonListener__mouseDown( event ) {
    var element = event.srcElement;
    var listener = null;
    while ( element ) {
        if ( element.nodeType == 1 && element.ButtonListener ) {
            listener = element.ButtonListener;
            break;
        }
    }
    if ( element != null && element.available ) {
        element.src = listener.imageBase + "Activated.png";
        element.addEventListener( "mouseup", ButtonListener__mouseUp, true );
        element.addEventListener( "mouseout", ButtonListener__mouseOut, true );
    }
}

function ButtonListener__mouseOut( event ) {
    var element = event.srcElement;
    var listener = null;
    while ( element ) {
        if ( element.nodeType == 1 && element.ButtonListener ) {
            listener = element.ButtonListener;
            break;
        }
    }
    if ( element != null && element.available ) {
        element.src = listener.imageBase + ".png";
        element.removeEventListener( "mouseup", ButtonListener__mouseUp, true );
        element.removeEventListener( "mouseout", ButtonListener__mouseOut, true );
    }
}

function ButtonListener__mouseUp( event ) {
    var element = event.srcElement;
    var listener = null;
    while ( element ) {
        if ( element.nodeType == 1 && element.ButtonListener ) {
            listener = element.ButtonListener;
            break;
        }
    }
    if ( element != null && element.available ) {
        ButtonListener__mouseOut( event );
        listener.handler();
    }
}



function receiveWheelEvent( event ) {
    var delta = parseInt( event.wheelDelta * -.4 );
    if ( scroller.visible ) {
        var pos = scroller.getPosition() + delta;
        var limit = scroller.targetBounds.height - scroller.containerBounds.height;
        if ( pos < 0 ) pos = 0;
        if ( pos >= limit ) pos = limit;
        scroller.changeView( pos );
        scroller.refresh();
    }
}

function goForward( event ) {
    debug( "go forward " + ( ResultStatus.pageNumber + 1 ) + " / " + ResultStatus.totalPages );
    if ( ResultStatus.pageNumber >= ResultStatus.totalPages ) {
        debug( "last page" );
        return;
    }
    closeDetailedInformation();
    var url = _createURL( ResultStatus.keywords, ResultStatus.searchIndex, ResultStatus.pageNumber + 1 );

    var userInfo = { keywords    : ResultStatus.keywords, 
                     searchIndex : ResultStatus.searchIndex,
                     url         : url, 
                     itemPage    : ResultStatus.pageNumber + 1 };
    var loader = new SiteLoader( url, parseSearchResults, _loadingErrorHandler, userInfo );
    loader.xml = true;
    _startWaitTimer();
    loader.start();
}

function showStatus( message ) {
    var page_info = document.getElementById( "status" );
    if ( page_info ) {
        page_info.innerText = message;
    } else {
        debug( message );
    }
}

function _loadingErrorHandler( message, loader ) {
    showStatus( "Load failed" );
    if ( SiteLoader.prototype.existsRunningProcess() == false ) {
        debug( "stop timer" );
        _stopWaitTimer();
    } else {
        debug( "still exists running processes" );
    }
}

function goBackward( event ) {
    debug( "go backward " + ( ResultStatus.pageNumber - 1 ) );
    if ( ResultStatus.pageNumber <= 1 || isNaN( ResultStatus.pageNumber ) ) {
        debug( "first page" );
        return;
    }
    closeDetailedInformation();
    var url = _createURL( ResultStatus.keywords, ResultStatus.searchIndex, ResultStatus.pageNumber - 1 );

    var userInfo = { keywords    : ResultStatus.keywords, 
                     searchIndex : ResultStatus.searchIndex,
                     url         : url, 
                     itemPage    : ResultStatus.pageNumber - 1 };
    var loader = new SiteLoader( url, parseSearchResults, _loadingErrorHandler, userInfo );
    loader.xml = true;
    _startWaitTimer();
    loader.start();
}


function flipToFront() {
    var front = document.getElementById( "front" );
    var back  = document.getElementById( "behind" );

    // set preferences
    try {
        var textarea = document.getElementById( "letterContent" );
        //debug( textarea.value );//innerText );
        //debug( getInnerText( textarea ) );
        if ( window.widget ) {
            widget.setPreferenceForKey( textarea.value, "MAIL_CONTENT" );
        }
        if ( selectedAngel.email ) {
            if ( window.widget ) {
                widget.setPreferenceForKey( selectedAngel.email, "ANGEL" );
            }
            MailData.toAddress = selectedAngel.email;
        }
        MailData.toName = _makeLocalizedName( selectedAngel.firstName, selectedAngel.lastName );
        if ( window.widget ) {
            widget.setPreferenceForKey( MailData.toName, "ANGEL_NAME" );
        }
        MailData.mailContent = textarea.value;//getInnerText( textarea );
        var review_check_box = document.getElementById( "review" );
        var review_checked = ( review_check_box.value == "on" );
        reviewLoad = review_checked;
        debug( "reload : " + review_checked + ", " + review_check_box.value + ", " + review_check_box.checked );
        if ( review_checked ) {
            widget.setPreferenceForKey( "true", "DEFAULT_REVIEW_LOAD" );
        } else {
            widget.setPreferenceForKey( "false", "DEFAULT_REVIEW_LOAD" );
        }
    } catch ( e ) {
        debug( e );
    }

    if ( window.widget ) {
        widget.prepareForTransition( "ToFront" );
    }
    back.style.display = "none";
    front.style.display = "block";
    //setTimeout( findTrailers, 0 );
    if ( window.widget ) {
        //if ( ViewStatus.collapsed ) {
        widget.setCloseBoxOffset( 10, resizeParameter.y + 20 );
            //widget.setCloseBoxOffset( 20, 140 );
        //}
        setTimeout( "widget.performTransition();", 0 );
    }
}

function flipToBack() {
    var front = document.getElementById( "front" );
    var back  = document.getElementById( "behind" );
    resizeParameter.y = parseInt( document.defaultView.getComputedStyle( front ).getPropertyValue( "top" ) );

    var country = document.getElementById( "country" );
    var children = country.childNodes;
    for ( var i = 0; i < children.length; i++ ) {
        var node = children.item( i );
        if ( node.nodeType == 1 && node.tagName == "OPTION" ) {
            if ( node.value == Country ) {
                node.setAttribute( "selected", "true" );
            } else {
                node.removeAttribute( "selected" );
            }
        }
    }
    if ( window.widget ) {
        widget.prepareForTransition( "ToBack" );
    }
    back.style.display = "block";
    front.style.display = "none";
    // set position
    var fstyle = document.defaultView.getComputedStyle( front );
    var bstyle = document.defaultView.getComputedStyle( back );
    var by = resizeParameter.y;
    var bh = parseInt( bstyle.getPropertyValue( "height" ) );
    var fh = window.outerHeight;//parseInt( fstyle.getComputedStyle( "height" ) );
    if ( by + bh > fh ) {
        by = fh - bh;
    }
    back.style.top = by + "px";

    if ( window.SimpleABAccess ) {
        createAddressSelection();
    }

    //setTimeout( findTrailers, 0 );
    if ( window.widget ) {
        widget.setCloseBoxOffset( 10, by + 20 );
        setTimeout( "widget.performTransition();", 0 );
    }
}


function _changeCountry( code ) {
    if ( Country == code ) return;
    Country = code;
    //debug( "new country " + code );
    Product.prototype.countryCode = code;
    //var fieldMap = null;
    if ( code == "JP" ) {
        AmazonBaseURL = "http://webservices.amazon.co.jp/onca/xml";
        //AmazonBaseURL = "http://xml-jp.amznxslt.com/onca/xml";
        FieldMap = FieldMap_jp;
        CategoryMap = CategoryMap_jp;
    } else if ( code == "UK" ) {
        AmazonBaseURL = "http://webservices.amazon.co.uk/onca/xml";
        FieldMap = FieldMap_uk;
        CategoryMap = CategoryMap_uk;
    } else {
        AmazonBaseURL = "http://webservices.amazon.com/onca/xml";
        FieldMap = FieldMap_us;
        CategoryMap = CategoryMap_us;
    }
    var select = document.getElementById( "searchIndex" );
    if ( select ) {
        while ( select.firstChild ) select.removeChild( select.firstChild );
        var flag_first = true;
        for ( var key in FieldMap ) {
            var value = FieldMap[ key ];
            var option = document.createElement( "option" );
            if ( flag_first ) {
                var indexElem = document.getElementById( "indexText" );
                if ( indexElem ) {
                    indexElem.innerText = value;
                }
                ResultStatus.searchIndex = value;
                flag_first = false;
            }
            option.setAttribute( "value", key );
            option.appendChild( document.createTextNode( value ) );
            select.appendChild( option );
        }
    }
}

function changeCountry() {
    var select = document.getElementById( "country" );
    if ( select ) {
        var code = select.value;
        _changeCountry( code );
        if ( window.widget ) {
            widget.setPreferenceForKey( code, "COUNTRY" );
        }
    }
}

// wait timer
function _startWaitTimer() {
    if ( waitTimer ) {
        debug( "already running" );
        return;
    }

    var div = document.getElementById( "wait" );
    if ( div ) {
        div.style.display = "block";
        waitTimer = setInterval( _tickWaitTimer, 66 );
        _tickWaitTimer();
    }
}

function _tickWaitTimer() {
    //debug( "ticking " + waitCount );
    var div = document.getElementById( "wait" );
    if ( div ) {
        div.src = "Images/Wait" + waitCount + ".png";
    } else {
        debug( "no debug" );
    }
    waitCount ++;
    if ( waitCount >= 12 ) waitCount = 0;
}

function _stopWaitTimer() {
    if ( waitTimer == null ) return false;
    clearInterval( waitTimer );
    waitTimer = null;
    var div = document.getElementById( "wait" );
    div.style.display = "none";
    return true;
}

function _createURL( keywords, searchIndex, pageNumber ) {
    var baseurl       = AmazonBaseURL;
    var service       = "AWSECommerceService";
    var operation     = "ItemSearch";
    var responseGroup = "Medium,Images,Offers";
    var version       = "2004-11-10";

    responseGroup = "Medium,Images,Offers";//,Reviews";
    if ( reviewLoad == true ) {
        responseGroup += ",Reviews";
    }

    if ( pageNumber ) {
        if ( pageNumber > ResultStatus.totalPages || pageNumber < 0 ) {
            pageNumber = null;
        }
    }

    debug( "create URL with " + keywords + " " + searchIndex + " " + pageNumber );

    var url = baseurl + "?Service=" + service
        + "&SubscriptionId=" + SubscriptionID
        + "&Operation=" + operation
        + "&Keywords=" + keywords
        + "&SearchIndex=" + searchIndex
        + "&ResponseGroup=" + responseGroup
        + "&Version=" + version;
        //+ "&Sort=dummy"

    if ( sortOrder != null && sortOrder.length > 0 ) {
        url += "&Sort=" + sortOrder;
    }

//     if ( searchIndex != "default" ) {
//         var sort = _resolveSort( searchIndex, sortOrder );
//         if ( sort ) {
//             url += "&Sort=" + sort;
//         }
//     }

    if ( Country == "JP" ) {
        url += "&AssociateTag=wobsofweewidg-22";
    } else if ( Country == "UK" ) {
        url += "&AssociateTag=wobsofweewidg-21";
    } else {
        url += "&AssociateTag=wobsofweewidg-20";
    }
    
    if ( pageNumber ) {
        url += "&ItemPage=" + pageNumber;
    }
    //debug( url );
    return url;
}

var ViewStatus = new function() {
    this.collapsed = true;
    this.animating = false;
    this.initialized = false;
    this.topElement = null;
    this.bodyElement = null;
    this.bottomElement = null;
    this.timer = null;
    this.expander = null;
};

ViewStatus.initialize = function() {
    if ( this.topElement == null ) {
        this.topElement    = document.getElementById( "searchBar" );
        this.bodyElement   = document.getElementById( "tableContainer" );
        this.bottomElement = document.getElementById( "frameBottom" );
        this.container     = document.getElementById( "front" );

        this.expander = new Expander( this.container, 330, 400 );
        this.expander.maxSteps = 8;
        //this.expander.
    }
}

ViewStatus.expand = function() {
    ViewStatus.initialize();
    this.topElement.style.background = "url(Images/ExpandedTop.png)";
    this.bottomElement.style.display = "block";
    this.bodyElement.style.display   = "block";
    //this.container.style.height      = "300px";
    this.expander.callBack = null;
    this.collapsed = false;
    this.expander.expand();
};

ViewStatus.collapse = function() {
    ViewStatus.initialize();
    //this.container.style.height      = "80px";
    this.expander.callBack = ViewStatus__eraseBottom;
    this.expander.collapse();
    this.collapsed = true;
};

ViewStatus__eraseBottom = function() {
    ViewStatus.topElement.style.background = "url(Images/CollapsedBar.png)";
    ViewStatus.bottomElement.style.display = "none";
    ViewStatus.bodyElement.style.display   = "none";
};

function collapseView() {
    if ( ViewStatus.collapsed ) return;
    ViewStatus.collapse();
}

function expandView() {
    if ( ViewStatus.collapsed == false ) return;
    ViewStatus.expand();
    if ( scroller == null ) {
        scroller = newScroller( "tableContainer", "resultTable", "track", "thumb" );
    }
}


function execute() {
    var keywords = document.getElementById( "searchKeywords" ).value;
    if ( keywords == null || keywords.length == 0 ) {
        collapseView();
        ResultStatus.pageNumber = null;
        // close boxes
        refreshButtonImages();
        return;
    } else if ( ViewStatus.collapsed ) {
        expandView();
    }
    closeDetailedInformation();

    var searchIndex = document.getElementById( "searchIndex" ).value;
    createSortOrder( Country, selectedSearchIndex );
//     {
//         debug( "searchIndex : " + searchIndex );
//         ResultStatus.searchIndex = searchIndex;
//         return;
//     }
    var url = _createURL( keywords, searchIndex );


    var userInfo = { keywords:keywords, searchIndex:searchIndex, url:url, itemPage:1};
    var loader = new SiteLoader( url, parseSearchResults, _loadingErrorHandler, userInfo );    loader.xml = true;
    _startWaitTimer();
    loader.start();
}

function parseSearchResults( doc, userInfo ) {
    debug( "keywords    : " + userInfo.keywords );
    debug( "searchIndex : " + userInfo.searchIndex );
    debug( "itemPage    : " + userInfo.itemPage );
    debug( "url         : " + userInfo.url );
    if ( userInfo ) {
        if ( userInfo.keywords ) 
            ResultStatus.keywords = userInfo.keywords;
        if ( userInfo.itemPage ) 
            ResultStatus.pageNumber = userInfo.itemPage;
        if ( userInfo.searchIndex )
            ResultStatus.searchIndex = userInfo.searchIndex;
    }

    expandView();
    //outputDOMText( doc.firstChild );

    var response = doc.firstChild;
    //var errors = getElementAt( response, "OperationRequest/Errors" );
    var errors = getElementAt( response, "Items/Request/Errors" );
    var num = 1;

    // clear current results
    var container = document.getElementById( "resultTable" );
    while ( container.lastChild ) {
        container.removeChild( container.lastChild );
    }


    if ( errors ) {
        while ( true ) {
            var error = getElementAt( errors, "Error," + num );
            if ( error == null ) break;
            var code = getInsideTexts( error, "Code" );//getElementAt( error, "Code" );
            var message = getInsideTexts( error, "Message" );
            debug( code + ":  " + message + "\n" );
            num ++;
        }
        //outputDOMText( errors );//response );
    } else {
        var items = getElementAt( response, "Items" );
        var totalpages= parseInt( getInsideTexts( items, "", "TotalPages" ) );
        var totalhits = parseInt( getInsideTexts( items, "", "TotalResults" ) );
        ResultStatus.totalPages = parseInt( totalpages );
        ResultStatus.totalResults = parseInt( totalhits );

        //outputDOMText( response, debug );
        debug( "TOTAL PAGES   " + ResultStatus.totalPages );
        debug( "TOTAL RESULTS " + ResultStatus.totalResults );

        //var page_info = document.getElementById( "pageNumber" );
        //if ( page_info ) {
        if ( isNaN( ResultStatus.totalPages ) == false && ResultStatus.totalPages > 0 ) {
            showStatus( ResultStatus.pageNumber + " of " + ResultStatus.totalPages + " pages" );
            //page_info.innerText = ResultStatus.pageNumber + " of " + ResultStatus.totalPages + " pages";
        } else {
            showStatus( "Not found" );
            //page_info.innerText = "Not Found";
            //}
        }

        if ( isNaN( totalhits ) ) {
            totalhits = 1;
        }

        //debug( "total page " + totalpages + " results " + totalhits );
        var table = document.createElement( "div" );
        while ( table.lastChild ) table.removeChild( table.lastChild );
        if ( items ) {
            var num = 1;
            try {
                while ( true ) {
                    var item = getElementAt( items, "Item," + num );
                    if ( item == null ) break;
                    var row = _readProductResult( item );
                    if ( row ) {
                        table.appendChild( row );
                    }
                    num ++;
                }
            } catch ( e ) {
                debug( "error in reading XML" );
            }
        }
        container.appendChild( table );
    }
    _stopWaitTimer();
    if ( scroller ) {
        scroller.changeView( 0 );
        scroller.refresh();
    }
    refreshButtonImages();
}

function itemSelected( event ) {
    //debug( "selected " );
    refreshButtonImages();
    var mail_button = document.getElementById( "detailMail" );
    var elem = event.srcElement;
    while ( elem ) {
        if ( elem.AmazonProduct ) {
            break;
        }
        elem = elem.parentNode;
    }
    if ( elem ) {
        var product = elem.AmazonProduct;
        var detailedURL = product.getURL();

        var detail = document.getElementById( "detailPanel" );
        if ( detail ) {
            var children = detail.childNodes;
            var contents = null;
            for ( var i = 0; i < children.length; i++ ) {
                if ( children.item( i ).id == "detailedInformation" ) {
                    contents = children.item( i );
                    break;
                }
            }
            detail.style.display = "block";
            while ( contents.firstChild ) {
                contents.removeChild( contents.firstChild );
            }
            var elem_product = product.createHTMLElement( null, { width:60, height:80 } );
            contents.appendChild( elem_product );
        }

        try {
            //debug( "set URL " + product.getAssociateURL() );
            MailData.attachedURL = product.getAssociateURL();
        } catch ( e ) {
        }
    }

}

function changeSearchIndex( event ) {
    var select = document.getElementById( "searchIndex" );
    var value = select.value;
    var children = select.childNodes;
    var index = null;
    var search_index = null;
    for ( var i = 0; i < children.length; i++ ) {
        var child = children.item( i );
        if ( child.value == value ) {
            index = getInnerText( child );
            search_index = child.value;
            break;
        }
    }
    if ( index ) {
        var indexElem = document.getElementById( "indexText" );
        if ( indexElem ) {
            indexElem.innerText = index;
        }
        selectedSearchIndex = search_index;
        createSortOrder( Country, search_index );
    }
}

function _readProductResult( item ) {

    var row = document.createElement( "div" );
    row.setAttribute( "class", "searchitem" );

    var icon = new Array();
    icon.url = getInsideTexts( item, '', "SmallImage/URL" );
    icon.width = getInsideTexts( item, '', "SmallImage/Width" );
    icon.height = getInsideTexts( item, '', "SmallImage/Height" );
    var asin = getInsideTexts( item, '', "ASIN" );
    var detailedURL = getInsideTexts( item, '', "DetailPageURL" );
    var attr = getElementAt( item, "ItemAttributes" );
    //debug( "detailed URL " + detailedURL );

    var price = new Array();
    var priceLowest = null;
    var priceUsed = null;

    //outputDOMText( item );

    var amazonPrice = getElementAt( item, "Offers/Offer/OfferListing/Price" );

    if ( amazonPrice == null ) { // apply list price
        amazonPrice = getElementAt( attr, "ListPrice" );
    }

    if ( amazonPrice ) {
        price.amount = getInsideTexts( amazonPrice, '', "Amount" );
        price.currency = getInsideTexts( amazonPrice, '', "CurrencyCode" );
        price.formatted = getInsideTexts( amazonPrice, '', "FormattedPrice" );
    }
    var availability = getInsideTexts( item, "", "Offers/Offer/OfferListing/Availability" );

    // get market prices
    var priceList;
    priceList = getElementAt( item, "OfferSummary/LowestNewPrice" );
    if ( priceList ) {
        priceLowest = new Array();
        priceLowest.amount = getInsideTexts( priceList, '', "Amount" );
        priceLowest.currency = getInsideTexts( priceList, '', "CurrencyCode" );
        priceLowest.formatted = getInsideTexts( priceList, '', "FormattedPrice" );
    }

    priceList = getElementAt( item, "OfferSummary/LowestUsedPrice" );
    if ( priceList ) {
        priceUsed = new Array();
        priceUsed.amount = getInsideTexts( priceList, '', "Amount" );
        priceUsed.currency = getInsideTexts( priceList, '', "CurrencyCode" );
        priceUsed.formatted = getInsideTexts( priceList, '', "FormattedPrice" );
    }

    var salesRank = getInsideTexts( item, '', "SalesRank" );
    var group = getInsideTexts( attr, '', "ProductGroup" );
    var title = getInsideTexts( attr, '', "Title" );
    var manufacturer = getInsideTexts( attr, '', "Manufacturer" );
    var product;

    if ( group == "Book" ) {
        product = new BookProduct();
    } else if ( group == "DVD" || group == "VHS" || group == "Video" ) {
        product = new DVDProduct();
    } else if ( group == "Video Games" || group == "Software" ) {
        product = new VideoGameProduct();
    } else if ( group == "Jewerly" || group == "Watch" || group == "Apparel" ) {
        product = new BrandProduct();
    } else if ( group == "Toy" ) {
        product = new ToyProduct();
    } else if ( group == "Music" || group == "Classical" ) {
        product = new MusicProduct();
    } else {
        product = new Product();
    }

    try {
        if ( group ) {
            product.setCategory( group );
            //debug( group + " => " + CategoryMap[ group ] );
            var category = CategoryMap[ group ];
            if ( category ) product.setCategory( category );
        } else {
            debug( "unknown group " + group );
        }

        var reviews = getElementAt( item, "CustomerReviews" );
        if ( reviews ) {
            var rate_average = parseFloat( getInsideTexts( reviews, "", "AverageRating" ) );
            var num_review = parseInt( getInsideTexts( reviews, "", "TotalReviews" ) );
            //debug( product.setReviewRage );
            //debug( "AVG: " + rate_average + ", NUM: " + num_review );
//             if ( isNaN( rate_averate ) == false && isNaN( num_review ) == false ) {
//                 debug( "set rate" );
            product.setReviewRate( rate_average, num_review );
//             } else {
//                 product.setReviewRate( null, null );//rate_average, num_review );
//                 debug( "not a number" );
//             }
        }

    } catch ( e ) {
        debug( e );
    }
    product.setSalesRank( salesRank );
    product.setAvailability( availability );
    product.setTitle( title );
    product.setURL( detailedURL );
    product.setASIN( asin );
    product.setPrice( price.amount, price.currency, price.formatted );
    if ( priceLowest ) {
        product.setLowestNewPrice( priceLowest.amount, priceLowest.currency, priceLowest.formatted );
    }
    if ( priceUsed ) {
        product.setLowestUsedPrice( priceUsed.amount, priceUsed.currency, priceUsed.formatted );
    }
    product.setIcon( icon.url, icon.width, icon.height );
    product.setManufacturer( manufacturer );

    product.importAttributes( attr );

    var elem = product.createHTMLElement();

    row.appendChild( elem );
    row.AmazonProduct = product;
    row.addEventListener( "click", itemSelected, true );

    return row;
}


function _getSortKey( country, index ) {
    if ( country == null ) country = "";
    if ( index == null ) index = "Blended";
    return "SORTKEY_" + country + "_" + index;
}

function createSortOrder( country, searchindex ) {
    var select = document.getElementById( "sortby" );
    while ( select.firstChild ) select.removeChild( select.firstChild );
//     var children = select.getElementsByTagName( "OPTION" );
//     for ( var i = 0; i < children.length; i++ ) {
//         select.removeChild( children[ i ] );
//     }

    var sort_key = country + "_" + searchindex;
    var order_default = null;
    if ( window.widget ) {
        order_default = widget.preferenceForKey( _getSortKey( country, searchindex ) );
    }
    debug( sort_key + " pref: " + order_default );
    var orders = availableSortOrder[ sort_key ];
    var description = document.getElementById( "sortOrder" );
    if ( order_default == null ) {
        description.innerText = tr( "Default" );
        sortOrder = '';
    }
    if ( orders ) {
        for ( var i = 0; i < orders.length; i++ ) {
            var name = orders[ i ];
            var key;
            if ( i >= sortOrders.length ) {
                var items = name.split( ":" );
                name = items[ 0 ];
                key  = items[ 1 ];
            } else {
                key = sortOrders[ i ];
            }
            //debug( name + " " + key );
            if ( name != null ) {
                //if ( name == '' ) name = "default";
                var option = document.createElement( "option" );
                option.setAttribute( "value", name );
                if ( order_default == name ) {
                    sortOrder = name;
                    option.setAttribute( "selected", "true" );
                    description.innerText = tr( key );
                }
                option.appendChild( document.createTextNode( tr( key ) ) );
                select.appendChild( option );
            }
        }
    } else {
        description.innerText = "";
        debug( "no available sort" );
    }
}

function _changeSortOrder( order ) {
    var select = document.getElementById( "sortby" );
    var children = select.getElementsByTagName( "OPTION" );
    var display_name = null;
    if ( order == '' ) {
        display_name = getInnerText( children[ 0 ] );
    } else {
        for ( var i = 0; i < children.length; i++ ) {
            var child = children[ i ];
            if ( child.value == order ) {
//            child.setAttribute( "selected", true );
                display_name = getInnerText( child );
//         } else {
//             child.removeAttribute( "selected" );
            }
        }
    }
    sortOrder = order;
    debug( "ORDER : " + order + ", NAME : " + display_name );
    var ordername = document.getElementById( "sortOrder" );
    if ( display_name ) {
        ordername.innerText = display_name;
    } else {
        ordername.innerText = "??";
    }
}

function changeSortOrder() {
    var select = document.getElementById( "sortby" );
    if ( select == null ) return null;
    var value = select.value;
    var order_current = sortOrder;
    //debug( value );
    if ( value != null ) {
        _changeSortOrder( value );
    }
    if ( order_current != sortOrder ) {
        var key = _getSortKey( Country, selectedSearchIndex );
        //debug( "new key " + key + " : " + sortOrder );
        widget.setPreferenceForKey( sortOrder, key );
        execute();
        //debug( "page to 1 and reload" );
    }
}
